# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Caffeinated Code <http://caffeinatedco.de>
# Copyright (C) 2012 Jono Cooper
# Copyright (C) 2012 George Czabania
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gettext
from gettext import gettext as _
gettext.textdomain('gradiator')

import os, sys, gtk, webkit, webbrowser, re
import logging
logger = logging.getLogger('gradiator')

from gradiator_lib import Window
from gradiator_lib.helpers import get_media_file, show_uri, get_help_uri

# See gradiator_lib.Window.py for more details about how this class works
class GradiatorWindow(Window):
    __gtype_name__ = "GradiatorWindow"

    
    
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the main window"""
        super(GradiatorWindow, self).finish_initializing(builder)

        def help():
            show_uri(self, "ghelp:%s" % get_help_uri())

        self.set_size_request(400, 427)
        self.set_position(gtk.WIN_POS_CENTER)
        self.set_resizable(False)

        scroller = gtk.ScrolledWindow()      

        #Load app into wrapper
        browser = webkit.WebView()
        browser.props.settings.props.enable_default_context_menu = False
        browser.load_uri(get_media_file('src/index.html'))

        scroller.add(browser)

        self.add(scroller)
        self.show_all()


        
        
        # Note: All message passing stuff appears between these curly braces:
        # {
        def title_changed(widget, frame, title):
            if title != 'null':

		        title = title.split("|")

		        if title[0] == 'copy':

		        	# change <br> to \n
		        	title[1] = title[1].replace("<br>","\n")

			        # get the clipboard
			        clipboard = gtk.clipboard_get()

			        # read the clipboard text data. you can also read image and
			        text = clipboard.wait_for_text()

			        # set the clipboard text data
			        clipboard.set_text(title[1])

			        # make our data available to other applications
			        clipboard.store()

                elif title[0]  == 'help':
                    help()

		        elif title[0] == 'web':
			        new = 2 # open in a new tab, if possible

			        # open the page
			        url = title[1]
			        webbrowser.open(url,new=new)

		        elif title[0] == 'color':

                    cdia = gtk.ColorSelectionDialog("Select color")
                    cdia.set_transient_for(self)
                    cdia.set_resizable(False)
                    cdia.set_position(gtk.WIN_POS_CENTER_ON_PARENT)

			        #sets default color
			        cdia.colorsel.set_current_color(gtk.gdk.Color(title[1]))
			
			        #runs dialog
			        response = cdia.run()

			        if response == gtk.RESPONSE_OK:
				        color = cdia.colorsel.get_current_color()

				        # Converts to RGB, not crazy color
				        finalColor = 'rgb(';
				        finalColor += str(color.red / 256) + ','
				        finalColor += str(color.green / 256)  + ','
				        finalColor += str(color.blue / 256)  + ')'

				        #Requires function to be global
				        browser.execute_script('replaceColor("' + finalColor + '")')

			        cdia.destroy()

        #fires whenever title is changed
        browser.connect('title-changed', title_changed)
        # }


